/******************************************************
*
*  Copyright:    Infinetix Incorporated, 2001
*
*  Program File: bq2040.h
*  Author:       Dan Parker
*
*  Description:  This include file provides object
*		 oriented support for the bq2040 I2C 
*		 bus device.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*******************************************************/

#ifndef BQ2040_H

#define BQ2040_H
#include "i2cdevice.h"

class Cbq2040 : public Ci2cDev
{
public:
   Cbq2040(void);
   int read( unsigned int code, unsigned char *data );
   int write( unsigned char Code, unsigned short Value );
   int ManufacturerAccess( unsigned short *ReadData );
   int WriteManufacturerAccess( unsigned short Value );
   int RemainingCapacityAlarm( unsigned short *ReadData );
   int WriteRemainingCapacityAlarm( unsigned short Value );
   int RemainingTimeAlarm( unsigned short *ReadData );
   int WriteRemainingTimeAlarm( unsigned short Value );
   int BatteryMode( unsigned short *ReadData );
   int WriteBatteryMode( unsigned short Value );
   int AtRate( short *ReadData );
   int WriteAtRate( short Value );
   int AtRateTimeToFull( unsigned short *ReadData );
   int AtRateTimeToEmpty( unsigned short *ReadData );
   int AtRateOK( unsigned short *ReadData );
   int Temperature( unsigned short *ReadData );
   int Voltage( unsigned short *ReadData );
   int Current( short *ReadData );
   int AverageCurrent( short *ReadData );
   int MaxError( unsigned short *ReadData );
   int RelativeStateOfCharge( unsigned short *ReadData );
   int AbsoluteStateOfCharge( unsigned short *ReadData );
   int RemainingCapacity( unsigned short *ReadData );
   int FullChargeCapacity( unsigned short *ReadData );
   int RunTimeToEmpty( unsigned short *ReadData );
   int AverageTimeToEmpty( unsigned short *ReadData );
   int AverageTimeToFull( unsigned short *ReadData );
   int ChargingCurrent( unsigned short *ReadData );
   int ChargingVoltage( unsigned short *ReadData );
   int BatteryStatus( unsigned short *ReadData );
   int CycleCount( unsigned short *ReadData );
   int DesignCapacity( unsigned short *ReadData );
   int DesignVoltage( unsigned short *ReadData );
   int SpecificationInfo( unsigned short *ReadData );
   int ManufactureDate( unsigned short *ReadData );
   int SerialNumber( unsigned short *ReadData );
   int ManufacturerName( unsigned char *ReadData );
   int DeviceName( unsigned char *ReadData );
   int DeviceChemistry( unsigned char *ReadData );
   int ManufacturerData( unsigned char *ReadData );
   int Flags( unsigned short *ReadData );
   int EndOfDischargeVoltage1( unsigned short *ReadData );
   int EndOfDischargeVoltageF( unsigned short *ReadData );
   ~Cbq2040(void);
private:

};

#endif
